library ieee ;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

ENTITY position_latch IS
    GENERIC (WIDTH      : integer :=16);
    PORT (
        DATA   : IN std_logic_vector (15 downto 0);
        RST     : IN std_logic; 
        CLK    : IN std_logic;
        OE	: IN std_logic;
        SEL	: IN std_logic;
        inh     : IN std_logic;
        Q : OUT std_logic_vector(7 downto 0)
    );
END position_latch ;

ARCHITECTURE behv OF position_latch IS
 

signal Qtmp	 : std_logic_vector (15 downto 0);


BEGIN

       PROCESS(Clk,rst,Data)
       BEGIN


           	 if(rst = '0') then
                          Qtmp <= "0000000000000000";
                   elsif (CLK = '1' and CLK'event) then
                          Qtmp <= DATA;
						  end if;
              

       END PROCESS;

  PROCESS(CLK,SEL,OE,qtmp,inh,q)
	BEGIN
	 if (CLK = '1' and CLK'event) then
	 	if(sel ='0' and oe='0' and inh ='1') then
	 		Q <=qtmp(15 downto 8);
	 	elsif( sel = '1' and oe ='0' and inh ='1') then
	 			Q <=qtmp(7 downto 0);
			 elsif(oe ='1' and inh ='0') then
	 				q <= "zzzzzzzz";
					
	 else
		 	
		end if;
		
	 end if;

 END PROCESS;
 

END behv;


